//==========================================================
// Layer
//---------
// This class stores timesediments
// The scenes class will store three instances of this class,
// one
// for the now-section, the other for the past-section and 
// the last for the future-section of the A-Line
// =========================================================


/**
 * Layer Constructor
 */

function Layer(layerXML) {

  

   // instance properties
   this.textBeginning = 0;
   this.textEnding = 0;
   this.layerNumber = 0;
   this.absoluteTimeString ="";
   this.granularity = "";
   this.timeRelatedLayers = new Array();

   //initialization
   this.setTextBeginning(parseInt(layerXML.childNodes[0].firstChild.nodeValue));
   this.setTextEnding(parseInt(layerXML.childNodes[1].firstChild.nodeValue));
   this.setLayerNumber(parseInt(layerXML.attributes.LNUM));
   this.absoluteTimeString = layerXML.attributes.ABSOLUTE;
   this.granularity = layerXML.attributes.GRANULARITY;
   if (layerXML.childNodes.length >=3) // Falls Time_Realationsknoten verfgbar
   {
	var timeDistanceObject;
	var currentReferencedLayer;
	for (var i =0;i < layerXML.childNodes[2].childNodes.length;i++){
	 currentReferencedLayer = layerXML.childNodes[2].childNodes[i];
	timeDistanceObject = new TimeDistance(this.layerNumber,currentReferencedLayer.attributes.RLNUM,currentReferencedLayer.attributes.TIME_DISTANCE,currentReferencedLayer.attributes.GRANULARITY)
	 
	
	this.timeRelatedLayers.push(timeDistanceObject);
	
   } 

}

/**
 * Method: getTextBeginning
 */

Layer.prototype.getTextBeginning = function(){
	return this.textBeginning;
}



/**
 * Method: setTextBeginning
 */


Layer.prototype.setTextBeginning = function(textBeginning) {
	this.textBeginning = textBeginning;
};



/**
 * Method: getTextEnding
 */

Layer.prototype.getTextEnding = function(){
	return this.textEnding;
}


/**
 * Method: setTextEnding
 * Desc: 
 *
 * @param 
 * @param 
 *
 */

Layer.prototype.setTextEnding = function(textEnding){
	this.textEnding = textEnding;
};


/**
 * Method: getLayerNumber
 */

Layer.prototype.getLayerNumber = function(){
	return this.layerNumber;
}


/**
 * Method: setLayerNumber
 * Desc: 
 *
 * @param 
 * @param 
 *
 */

Layer.prototype.setLayerNumber = function(layerNumber) {
	this.layerNumber = layerNumber;
};
