//===================================================================
// TempusPlotter
//-----------------
// Main class, handles almost everything
// ==================================================================



/**
 * TempusPlotter Conctructor
 *
 */

   function TempusPlotter() {
     //trace("Tempusplotter erzeugt");
	this.scenes = new Array();		// Array of scene objects
	this.tempusPlotterGUI = null;		//
	this.cTextString = "";			// Whole C-Text in a String 
	this.actualScene = -1;		
	
}


//-------------------------------------------------------------------
/**
 * Method: loadTempusPlotterData(URL_Text,URL_Scenes)
 * Desc: Loads the Data for the TempusPlotter: C-Text and Scene-data
 * 
 * @ param URL_Text URL of the C-Text to be loaded
 * @ param URL_Scenes URL of the scenes to be loaded
 *
 */ 

TempusPlotter.prototype.loadTempusPlotterData = function (URL_Text, URL_Scenes) {

	



	this.loadText(URL_Text);
	this.loadScenes(URL_Scenes);
	
};


//-------------------------------------------------------------------
/**
 * Method: loadText(URL)
 * Desc: Loads the C-Text  for the TempusPlotter
 * 
 * @ param URL URL of the C-Text to be loaded
 * 
 */ 


	TempusPlotter.prototype.loadText = function (URL) {
	var tempusPlotter = this;
	XML.prototype.ignoreWhite = true;
	cText_xml = new XML();
	cText_xml.load(URL);

	// On loading assign text to Stringfield cTextString, then
	// let TempusPlotterGUI display the scene
	
	
	cText_xml.onLoad = function() {
		
		//After Loading do: 
		
		//  get the text
		tempusPlotter.cTextString = 
             new String(cText_xml.firstChild.firstChild.nodeValue);
		

		
			
	}
};

//-------------------------------------------------------------------
/**
 * Method: loadScenes(URL)
 * Desc: Loads Scenes Data  for the TempusPlotter from an XML File
 * 
 * @param  URL of the Scenes Data to be loaded
 * 
 */ 


	TempusPlotter.prototype.loadScenes = function (URL) {
	
	

	   // convenient reference for callbackfunction
		var tempusPlotter = this;
		XML.prototype.ignoreWhite = true;
		scenes_xml = new XML();
		scenes_xml.load(URL);

	  // On loading the scenes data do ... 

		scenes_xml.onLoad = function() {

		// 1.) ... store them in the scenesArray
		   var sceneNodes = this.firstChild.childNodes;	
		   for (var i = 0; i < sceneNodes.length; i++)
		   {
			tempusPlotter.addScene(new Scene(sceneNodes[i]));
		   }
			
		// 2.) let the Gui know and display the Scene

		tempusPlotter.tempusPlotterGUI.display();
	
			
	

		
		}; 

	
	};


//-------------------------------------------------------------------
/**
 * Method: addScene()
 * Desc: adds an scene object to the array of scenes
 * 
 * @param  sceneObject  A reference to a scene object to be added 
 * @param index  The position which to be added at
 */

 Tempusplotter.prototype.addScene = function(sceneObj, index) {
	// in case there is only one argument, push the sceneobject
	if (typeof index != "number") {
		this.scenes.push(sceneObj);
		
	} else {
	  this.scenes.splice(index,0,sceneObj);
	}
};	





//====================================================================
//	 Getter and Setter Methods
//====================================================================

/** 
 * Method: getCTextString
 *
 */

TempusPlotter.prototype.getCTextString = function(){
	return this.cTextString;
}

/** 
 * Method: setCTextString
 *
 */

TempusPlotter.prototype.setCTextString = function(cTextString){
	this.cTextString = cTextString;
}







/**
 * Method setTempusPlotterGUI()
 * Desc: Sets the reference to the TempusPlotterGUI
 *
 * @param tempusPlotterGUI A reference to a TempusPlotterGUI instance
*/
	
	TempusPlotter.prototype.setTempusPlotterGUI = function (tempusPlotterGUI){
	this.tempusPlotterGUI = tempusPlotterGUI;
};


/**
 * Method: getActualScene
 * 
 */

TempusPlotter.prototype.getActualScene = function(){	


return this.actualScene;

}

/**
 * Method: setActualScene
 *
 */

TempusPlotter.prototype.setActualScene = function(actualScene){
	this.actualScene = actualScene;
	// Nachricht an die GUI, dass neue Szene ansteht 
	this.tempusPlotterGUI.onSceneUpdate();	
}



/**
 * Method: getScenes
 * 
 */

TempusPlotter.prototype.getScenes = function(){
	
	return this.scenes;
}

/**
 * Method: setScenes
 *
 */

TempusPlotter.prototype.setScenes = function(scenes){
	this.scenes = scenes;
}
