//===================================================================
// TempusPlotterGUI
//-----------------
// This class displays the texts and data stored in TempusPlotter.as
// ==================================================================


//----------------------------------------------------------------------------
/**
 * TempusPlotterGUI Conctructor
 * @param this.tempusPlotterClip	   // The clip used to display the quiz.
 * @param tempusPlotterObject	   //	The TempusPlotter instance
 */
//-----------------------------------------------------------------------------


function TempusPlotterGUI (tempusPlotterClip, tempusPlotterObject){
	
	//trace("TempusPlotterGUI erzeugt");
	this.tempusPlotterClip = tempusPlotterClip;
	this.tempusPlotterObject = tempusPlotterObject;
	this.depthCounter = 0; 				// a unique depthcounter

	


	
	//Initialization
	// Set movie scale mode and alignment
	//Stage.scaleMode = "noScale";
	//Stage.scaleMode = "exactFit";
	Stage.scaleMode = "showAll";
	//Stage.scaleMode = "noBorder";


		
	
	// "Private" properties concerning the position of the elements on the stage
	this.xPos_cText = (Stage.width)*(3/4);
	this.yPos_cText = (Stage.height)*(3/20);
	this.height_cText = (Stage.height)*(7/10) ;
	this.width_cText = (Stage.width)*(1/4);
	this.xPos_NowColumn = 110;
	this.xPos_PastColumn = 0;
	this.xPos_FutureColumn = 260;
	this.xPos_ChangeSceneButtons = 110;
	this.yPos_ChangeSceneButtons = 310;
	this.width_PopUpText = 160;
	this.width_futureCube = 80;
	this.height_futureCube = 15;
	this.width_nowCube = 100;
	this.height_nowCube = 20;
	this.width_pastCube = this.width_futureCube;
	this.height_pastCube = this.height_futureCube;
	this.color_TimeDetails = 0xffccff;
	this.color_PastColumn = 0x00ccff;
	this.yPos_Columns = 250;



};




//------------------------------------------------------------------
/** Method: TempusPlotterGUI.display
 *  Desc:   Displays the whole scene
 *  First the main textfield and the buttons are created
 *  Second the columsn are drawn
 *  Third the Fadein fadeout rectangular and his buttons are drawn
 */
//------------------------------------------------------------------

TempusPlotterGUI.prototype.display = function() {
   

	this.depthCounter = 0;	// on begin of displaying set depthcounter back to 0
	this.displayScene();	
	this.displayMainText();
	
	


}; // Ende der Methode display()


//--------------------------------------------------------
/**
 * Method displayScene()
 *
 */
//--------------------------------------------------------


TempusPlotterGUI.prototype.displayScene = function(){


//variable for reference in callback function
var tempusPlotterClip = this.tempusPlotterClip;
var tempusPlotterGUI = this;
var tempusPlotterObject = this.tempusPlotterObject;
	


	

  //==========================================================
  //  Draw cubes
  //==========================================================

if (this.tempusPlotterObject.getActualScene() >=0) { //display in case we have a scene
  // Create MovieClip, which contains  all cubes
	var scene_mc = this.tempusPlotterClip.createEmptyMovieClip("scene_mc",++this.depthCounter);
	scene_mc._x = 0;
	scene_mc._y = 0;
	scene_mc._alpha = 0;
	var locDepthCounter = 0;
	locDepthCounter = this.drawColumn(scene_mc, this.xPos_PastColumn, this.yPos_Columns,"pastColumn",locDepthCounter);
	locDepthCounter = this.drawColumn(scene_mc,this.xPos_NowColumn, this.yPos_Columns,"nowColumn",locDepthCounter);
	locDepthCounter = this.drawColumn(scene_mc,this.xPos_FutureColumn, this.yPos_Columns,"futureColumn",locDepthCounter);



  	//===============================
  	// Fade in mechanism for scene_mc
  	//===============================
	
      	scene_mc.onEnterFrame = function(){
			if (scene_mc._alpha < 105)
			{
				scene_mc._alpha +=5;
			}	
		}

} // end of if-body


	// ----------------------------------
	// Buttons for changing between scenes
	// ----------------------------------



	

	//--------------
	// Next-Button
	//--------------

	var nextScene_mc = this.tempusPlotterClip.createEmptyMovieClip("nextScene_mc",++this.depthCounter);
	nextScene_mc.createTextfield("next_txt",1,0,0,0,0);
	
	//nextScene_mc.next_txt.background = true;
	//nextScene_mc.next_txt.backgroundColor = 0x3366ff;
	nextScene_mc.next_txt.autoSize = true;
	
	nextScene_mc.next_txt.border = true;
	//nextScene_mc._x = backScene_mc._width + 5 + reset_mc._width +5;
	nextScene_mc._y = this.yPos_ChangeSceneButtons;
	//Use Embedded Font to make _alpha property accessible
	nextScene_mc.next_txt.embedFonts = true;
	
	defaultFormat = new TextFormat();
	defaultFormat.font ="Arial";
	defaultFormat.size = 8;
	nextScene_mc.next_txt.text = "Next";
	nextScene_mc.next_txt.setTextFormat(defaultFormat);
	


	var backScene_mc = this.tempusPlotterClip.createEmptyMovieClip("backScene_mc",++this.depthCounter);
	backScene_mc.createTextfield("back_txt",1,0,0,0,0);
	
	//backScene_mc.back_txt.background = true;
	//backScene_mc.back_txt.backgroundColor = 0x3366ff;
	backScene_mc.back_txt.autoSize = true;
	backScene_mc.back_txt.border = true;
	backScene_mc._x = this.xPos_ChangeSceneButtons;
	backScene_mc._y = this.yPos_ChangeSceneButtons;
	//Use Embedded Font to make _alpha property accessible
	backScene_mc.back_txt.embedFonts = true;
	backScene_mc.back_txt.text = "Back";
	backScene_mc.back_txt.setTextFormat(defaultFormat);
	backScene_mc._alpha = 100;

	//--------------
	// Reset-Button
	//--------------

	var reset_mc = this.tempusPlotterClip.createEmptyMovieClip("reset_mc",++this.depthCounter);
	reset_mc.createTextfield("reset_txt",1,0,0,0,0);
	
	//reset_mc.reset_txt.background = true;
	//reset_mc.reset_txt.backgroundColor = 0x3366ff;

	reset_mc.reset_txt.autoSize = true;
	reset_mc.reset_txt.border = true;
	reset_mc._x = this.xPos_ChangeSceneButtons + backScene_mc._width+ 5;
	reset_mc._y = this.yPos_ChangeSceneButtons;
	reset_mc.reset_txt.embedFonts = true;
	reset_mc.reset_txt.text = "Reset";
	reset_mc.reset_txt.setTextFormat(defaultFormat);

	// Position von nextScene_mc hier festgelegt, damit Variablen backScene_mc und reset_mc bekannt sind
	nextScene_mc._x = this.xPos_ChangeSceneButtons + backScene_mc._width +reset_mc._width +10;



	//---------------------------
	// Call-Back for Reset-Button
	//---------------------------

	reset_mc.onPress = function(){
	tempusPlotterObject.setActualScene(-1);
	}

	//---------------------------
	// Callback for Nextbutton
	//---------------------------
	
	
	//nextScene_mc.next_mc; // variable in nextSceneButton which stores locally the number of the next scen
	nextScene_mc.onEnterFrame = function(){ 
	//var next_mc; 

	// If nothing is selected (that is, if in the ctext nothing is selected), then increment next_mc-number)
  	if (Selection.getCaretIndex() == -1) 
	{  

		if (tempusPlotterObject.getActualScene() < tempusPlotterObject.getScenes().length -1)
		{	
			nextScene_mc._alpha = 100;
			this.onPress = function(){
			
			tempusPlotterObject.setActualScene(tempusPlotterObject.getActualScene()+ 1);
			}
		} else {
				//new Color(nextScene_mc).setRGB(0x999999);
				nextScene_mc._alpha = 50;
				nextScene_mc.enabled = false;
			 }
			


	} 
	else	 	// otherwise find the next bigger scene scope number according to the postion
			// of the caret 
	{
		
		
		nextScene_mc._alpha = 100;
		nextScene_mc.enabled = true;
		var next_mc = 0;
		var caretPosition = Selection.getCaretIndex();
		var i;
		var beginIndex, endIndex;
		var scene;
		for (i = 0; i < tempusPlotterObject.scenes.length; i++)
		{
			scene = tempusPlotterObject.scenes[i];
			beginIndex = scene.scopeBeginning;
			endIndex = scene.scopeEnding;
			//trace(endIndex);
			//trace(beginIndex);
			//trace(caretPosition);
			if (beginIndex < caretPosition)
			{
				next_mc++;	
			}
		
		
		}
		
	this.onPress = function(){
		tempusPlotterObject.setActualScene(next_mc-1);
	}
		
		
	}




}



	//---------------------------
	// Callback for Backbutton
	//---------------------------



backScene_mc.onEnterFrame = function(){
	if (tempusPlotterObject.getActualScene() >= 0 && Selection.getFocus() == null )
	{	backScene_mc.enabled = true;
		backScene_mc._alpha = 100;
		backScene_mc.onPress = function(){
		  tempusPlotterObject.setActualScene(tempusPlotterObject.getActualScene()-1);		
		}
	} else { 

		if(Selection.getFocus() != null && !( eval(Selection.getFocus()) == tempusPlotterClip.cTextField_txt)) {}
else {
		backScene_mc.enabled = false;	
		backScene_mc._alpha = 50;
		}
			
    		  }
}




	//=================================================
	// Draw description "Past", "present", "future"
	//=================================================	
	
	//Create Texformat object
	


	this.tempusPlotterClip.createTextField("future_txt",++tempusPlotterGUI.depthCounter,0,0,0,0);
	
	this.tempusPlotterClip.future_txt.text = "Future";	
this.tempusPlotterClip.future_txt.setTextFormat(new TextFormat("Arial",16,0xFF0000));
	this.tempusPlotterClip.future_txt._x = this.xPos_futureColumn+20;
	this.tempusPlotterClip.future_txt._y = 0;
	this.tempusPlotterClip.future_txt.autosize = true;
	this.tempusPlotterClip.future_txt.background = true;
	this.tempusPlotterClip.future_txt.embedFonts = true;

	this.tempusPlotterClip.createTextField("past_txt",++tempusPlotterGUI.depthCounter,0,0,0,0);
	this.tempusPlotterClip.past_txt.text = "Past";	
	this.tempusPlotterClip.past_txt.setTextFormat(new TextFormat("Arial",16,0x0000FF));
	this.tempusPlotterClip.past_txt._x = this.xPos_PastColumn+20;
	this.tempusPlotterClip.past_txt._y = 0;
	this.tempusPlotterClip.past_txt.autosize = true;
	this.tempusPlotterClip.past_txt.background = true;
	//this.tempusPlotterClip.past_txt.embedFonts = true;

	this.tempusPlotterClip.createTextField("now_txt",++tempusPlotterGUI.depthCounter,0,0,0,0);
	this.tempusPlotterClip.now_txt.text = "Now";	
this.tempusPlotterClip.now_txt.setTextFormat(new TextFormat("Arial",18,0x00FF00));
	this.tempusPlotterClip.now_txt._x = this.xPos_nowColumn+40;
	this.tempusPlotterClip.now_txt._y = 0;
	this.tempusPlotterClip.now_txt.autosize = true;
	this.tempusPlotterClip.now_txt.background = true;
	//this.tempusPlotterClip.now_txt.embedFonts = true;



	//=========================================
	// Draw before-after arrow
	//=========================================

	//this.tempusPlotterClip.createEmptyMovieClip("beforeArrow_mc",++tempusPlotterGUI.depthCounter);
	//this.tempusPlotterClip.beforeArrow_mc.


}; // end of method displayScene() 


















//------------------------------------------------------
/**
 * Method TempusPlotterGUI.clearScreen()
 * 
 */
//------------------------------------------------------

TempusPlotterGUI.prototype.clearScreen = function () {
  for (var p in this.tempusPlotterClip) {
    if (typeof this.tempusPlotterClip[p] == "movieclip") {
      this.tempusPlotterClip[p].removeMovieClip();
    } else if (this.tempusPlotterClip[p] instanceof TextField) {
      this.tempusPlotterClip[p].removeTextField();
    }
  }
};



//-------------------------------------------------------------
/**
 * Method displayMainText()
 *
 */
//--------------------------------------------------------------


TempusPlotterGUI.prototype.displayMainText = function(){
	

	

	//-----------------------------
	// Create main textfield
	//-----------------------------

	this.tempusPlotterClip.createTextField("cTextfield_txt", ++this.depthCounter, 0,0, 0, 0);
   // Assign the cTextSring to the CTextfield
	this.tempusPlotterClip.cTextfield_txt.text = this.tempusPlotterObject.cTextString;
	this.tempusPlotterClip.cTextfield_txt._x = this.xPos_cText;
	this.tempusPlotterClip.cTextfield_txt._y = this.yPos_cText;
	this.tempusPlotterClip.cTextfield_txt._height = this.height_cText;
	this.tempusPlotterClip.cTextfield_txt._width = this.width_cText;
	this.tempusPlotterClip.cTextfield_txt.multiline = true;
	this.tempusPlotterClip.cTextfield_txt.border = true;
	this.tempusPlotterClip.cTextfield_txt.wordWrap = true;
    // There should be no input but the user has to have possibility to mark a 
    // position in the text: if the restrict-property is set to "" everything can be chosen -
    // a flashplayer 6 internal bug, so "~" is set as the only sign
	// which can be wrote into the textfield by the user. I hope no user will have the idea to enter this sign
	this.tempusPlotterClip.cTextField_txt.type = "input";
	this.tempusPlotterClip.cTextField_txt.restrict = "~"; 

    // set the vertical space between lines
	//format = new TextFormat();
	//format.leading = 0;
	//this.tempusPlotterClip.cTextField_txt.setTextFormat(format);

		




      //the Description of the Textfield
	this.tempusPlotterClip.createTextField("DescOfMainText_txt",++this.depthCounter,0,0,0,0);
	this.tempusPlotterClip.DescOfMainText_txt.text = "Main Text";
	this.tempusPlotterClip.DescOfMainText_txt.autoSize = true;
	this.tempusPlotterClip.DescOfMainText_txt.embedFont = true;
	this.tempusPlotterClip.DescOfMainText_txt.setTextFormat(new TextFormat("Arial",14,0x000000));
	this.tempusPlotterClip.DescOfMainText_txt._x = cTextfield_txt._x +
((cTextfield_txt._width -  DescOfMainText_txt._width)/2);
	//this.tempusPlotterClip.DescOfMainText_txt._y = cTextfield_txt._y/2;
	this.tempusPlotterClip.DescOfMainText_txt._y = 0;
	//this.tempusPlotterClip.DescOfMainText_txt.border = true;
	this.tempusPlotterClip.DescOfMainText_txt.selectable = false;
	//this.tempusPlotterClip.DescOfMainText_txt.background = true;
	//this.tempusPlotterClip.DescOfMainText_txt.backgroundColor = 0x00FFFF;




    	 //-------------------------------------------
    	 // Generate Buttons for Scrolling up and Down
   	 // ---------------------------------------------

	var scrollUp_mc =
this.tempusPlotterClip.createEmptyMovieClip("scrollUp_mc",++this.depthCounter);
	var scrollDown_mc =
this.tempusPlotterClip.createEmptyMovieClip("scrollDown_mc",++this.depthCounter);

   // Draw triangles in the Clips 
	


	// for Upscroller
	scrollUp_mc.lineStyle(0);
	scrollUp_mc.moveTo(0,14);
	scrollUp_mc.beginFill(0x3366ff);
	scrollUp_mc.lineTo(10,14);
	scrollUp_mc.lineTo(5,4);
	scrollUp_mc.lineTo(0,14);
	


	//for DownScroller
	scrollDown_mc.lineStyle(0);
	scrollDown_mc.moveTo(0,4);
	scrollDown_mc.beginFill(0x3366ff);
	scrollDown_mc.lineTo(5,14);
	scrollDown_mc.lineTo(10,4);
	scrollDown_mc.lineTo(0,4);
	
	//Position UpScroller
	scrollUp_mc._x = this.tempusPlotterClip.cTextfield_txt._x
+(this.tempusPlotterClip.cTextfield_txt._width)/2  - 14;
	scrollUp_mc._y = this.tempusPlotterClip.cTextfield_txt._y +
this.tempusPlotterClip.cTextfield_txt._height  +10;


	//Position DownScroller
	scrollDown_mc._x = this.tempusPlotterClip.cTextfield_txt._x + 
(this.tempusPlotterClip.cTextfield_txt._width)/2 +14;
	scrollDown_mc._y = this.tempusPlotterClip.cTextfield_txt._y +
this.tempusPlotterClip.cTextfield_txt._height  + 10;

	//convenient description for use in callback function
	var tempusPlotterClip = this.tempusPlotterClip;
	


	// Assign the buttons behaviour
		scrollDown_mc.onPress = function(){
			
			if (tempusPlotterClip.cTextfield_txt.scroll <
tempusPlotterClip.cTextfield_txt.maxscroll)
			{
					tempusPlotterClip.cTextfield_txt.scroll++;
					
			}
		};
		
		scrollUp_mc.onPress = function(){
			//trace("ScrollDown_mc bettigt");
			if (tempusPlotterClip.cTextfield_txt.scroll > 1)
			{
			
				tempusPlotterClip.cTextfield_txt.scroll--;
			}
		};
} // End of Method displayMainText





//-----------------------------------------------------------------
/**
 * Method drawCube()
 * @param mc the movieclip, which the cube is drawn into
 * @param content textstring to appear in front of the cubes
 * @param color  
 * @param cubeHeight
 * @param cubeWidth
 * @param layerID
 * 
 * Description: In case the number of arguments is smaller than 5
 * 		    cubes are drawn with default values
*/
//-----------------------------------------------------------------

TempusPlotterGUI.prototype.drawCube = function(mc,content,color,cubeHeight,cubeWidth,layerID) {
	//trace("Methode drawcube aufgerufen");
	var cubeXPosInClip = 0;
	var cubeYPosInClip = 30;

	if (arguments.length < 6){
		var layerID = -1;
	}
	if (arguments.length <5) {
	    var cubeWidth = 100;
	}
	if (arguments.length <4) {
		var cubeHeight = 30;
	}    
	if (arguments.length <3) {
		var color = 0xff0000; //red cube as defaultcolor	    
	}
	if (arguments.length < 2) {
		var content = "default";
	}
//Set ID-Number
mc.layerID = layerID;
mc.lineStyle(1, 0xFFFFFF, 100);
mc.beginFill(color,100);

mc.moveTo(cubeXPosInClip,cubeYPosInClip);
mc.lineTo(cubeXPosInClip + cubeWidth/3,cubeYPosInClip -cubeHeight/2);
mc.lineTo(cubeXPosInClip + (4/3)*cubeWidth,cubeYPosInClip -
cubeHeight/2);
mc.lineTo(cubeXPosInClip + (4/3)*cubeWidth,cubeYPosInClip +
cubeHeight/2);
mc.lineTo(cubeWidth +this.cubeXPosInClip,cubeYPosInClip + cubeHeight);
mc.lineTo(cubeXPosInClip,cubeYPosInClip + cubeHeight);
mc.lineTo(cubeXPosInClip,cubeYPosInClip);
mc.endFill();

//Draw inner "Y" of the cube
mc.lineTo(cubeXposInClip+cubeWidth,cubeYPosInClip);
mc.lineTo(cubeXPosInClip +4/3*cubeWidth,cubeYPosInClip-cubeHeight/2);
mc.moveTo(cubeXposInClip+cubeWidth,cubeYPosInClip);
mc.lineTo(cubeXposInClip+cubeWidth,cubeYPosInClip +  cubeHeight);


  //create Textfield into the front of the cube and 
  // initialize with specified textstring content
mc.createTextField("content_txt",1,cubeXPosInClip,cubeYPosInClip,cubeWidth-10,cubeHeight);

//Use Embedded Font to make _alpha property accessible
mc.content_txt.embedFonts = true;
mc.content_txt.text = content;
defaultFormat = new TextFormat();
defaultFormat.font ="Arial";
defaultFormat.size = 8;
mc.content_txt.setTextFormat(defaultFormat);

};



//-------------------------------------------------------------------
/**
 * Method drawTimeArrow
 * @param mc The movieclip which to draw the arrow into
 * @param xPos
 * @param yPos_FirstPoint
 * @param yPos_SecondPoint
 * @param horizDistance
 * @param timeDistance 
 */
//--------------------------------------------------------------

TempusPlotterGUI.prototype.drawTimeArrow = function(mc,xPos,yPos,verticalDistance, horizDistance,timeDistance,locDepthCounter)
{

	//trace("drawTimeArrow aufgerufen");
	mc.lineStyle(1,this.color_TimeDetails);
	mc.moveTo(xPos,yPos);
	mc.lineTo(xPos+horizDistance,yPos);
	mc.moveTo(xPos+horizDistance,yPos);
	mc.lineTo(xPos+horizDistance,yPos+verticalDistance);
	mc.moveTo(xPos+horizDistance,yPos+verticalDistance);
	mc.lineTo(xPos,yPos+verticalDistance);
	mc.createTextField("timeDistance_txt",locDepthCounter,xPos+horizDistance+5,yPos + verticalDistance/4,0,0);
	mc.timeDistance_txt.text = timeDistance;
	mc.timeDistance_txt.autosize = true;

	


}





//-------------------------------------------------------------------
/**
 * Method drawColumn
 */
//--------------------------------------------------------------

TempusPlotterGUI.prototype.drawColumn = function(scene_mc,xPos,yPos,columnType, depthCountOffset)
{
	//trace("drawColumn aufgerufen");


   //variable for reference in callback function
	var tempusPlotterClip = this.tempusPlotterClip;
	var tempusPlotterGUI = this;
	var tempusPlotterObject = this.tempusPlotterObject;
	
   // Other local variables
	var numberLayers;
	var layers;
	var verticalDistance;
	var nameOfCube;
	var locDepthCounter = depthCountOffset;
	var colour;
	var height;
	var width;
	//var absTime;
	//var timeRelatedLayers;

	if (columnType == "nowColumn")
	{ 	
		numberLayers = this.tempusPlotterObject.getScenes()[this.tempusPlotterObject.getActualScene()].getNowColumn().getLayers().length;
		layers = this.tempusPlotterObject.getScenes()[this.tempusPlotterObject.getActualScene()].getNowColumn().getLayers();
		verticalDistance = 0;
		nameOfCube = "ncube_mc_";
		colour = 0x00ff00;
		//height = 30;
		//width = 80;
		height = tempusPlotterGUI.height_nowCube;
		width = tempusPlotterGUI.width_nowCube;


	}
	if (columnType == "pastColumn")
	{
		numberLayers = this.tempusPlotterObject.getScenes()[this.tempusPlotterObject.getActualScene()].getPastColumn().getLayers().length;
		layers = this.tempusPlotterObject.getScenes()[this.tempusPlotterObject.getActualScene()].getPastColumn().getLayers();
		verticalDistance = (tempusPlotterGUI.height_pastCube)/4;
		nameOfCube ="pcube_mc_"	;	
		colour = this.color_PastColumn;
		height = tempusPlotterGUI.height_pastCube;
		width = tempusPlotterGUI.width_pastCube;
	}		
	if (columnType == "futureColumn")
	{
		numberLayers = this.tempusPlotterObject.getScenes()[this.tempusPlotterObject.getActualScene()].getFutureColumn().getLayers().length;
		layers = this.tempusPlotterObject.getScenes()[this.tempusPlotterObject.getActualScene()].getFutureColumn().getLayers();
		verticalDistance = (tempusPlotterGUI.height_futureCube)/4;
		nameOfCube = "fcube_mc_";
		colour = 0xff0000;
		height = tempusPlotterGUI.height_futureCube;
		width = tempusPlotterGUI.width_futureCube;
	}



	for (var i = 0;i < numberLayers;i++)
	{  
		var oneLayer = layers[(numberLayers-i-1)];
		//trace(layers[(numberLayers-i-1)]);
		var stringPart = this.getLayerString(oneLayer);
		var cube_mc = this.tempusPlotterClip.scene_mc.createEmptyMovieClip(nameOfCube +(numberLayers-i-1),++locDepthCounter);
		//trace(stringPart);
		this.drawCube(cube_mc,stringPart,colour,height,width,(numberLayers-i-1));
		cube_mc._x = xPos;
		
		
		
		if (i == 0)
 		{
			cube_mc._y = yPos;
		} else {
		 	cube_mc._y = this.tempusPlotterClip.scene_mc[nameOfCube+ (numberLayers-i)]._y - (height+ verticalDistance);
		}

		cube_mc.onRollOver = function()
		{
			
		//Create Popup text which contains the description of the layer
			tempusPlotterClip.createTextField("popUp_txt",tempusPlotterGUI.depthCounter+3,tempusPlotterGUI.xPos_pastColumn,tempusPlotterGUI.yPos_ChangeSceneButtons + 20,0,0);
			tempusPlotterClip.popUp_txt.text = this.content_txt.text;
			//tempusPlotterClip.popUp_txt.autosize = true;
			tempusPlotterClip.popUp_txt._width = 240;
			tempusPlotterClip.popUp_txt._height = 60;
			tempusPlotterClip.popUp_txt.wordwrap = true;
			tempusPlotterClip.popUp_txt.border = true;
			tempusPlotterClip.popUp_txt.background = true;
			tempusPlotterClip.popUp_txt.backgroundColor = 0xffffCC;
			tempusPlotterClip.popUp_txt.embedFonts = true;
			defaultFormat = new TextFormat();
			defaultFormat.font ="Arial";
			defaultFormat.size = 8;
			tempusPlotterClip.popUp_txt.setTextFormat(defaultFormat);

		// Now create another PopupTextfield, which shows an absolute
		//Time Description
			// Get absolute Timedescription and granularity
			var absTime = 	layers[this.layerID].absoluteTimeString;
			var absGranularity = layers[this.layerID].granularity;
			tempusPlotterClip.createTextField("absoluteTime_txt",tempusPlotterGUI.depthCounter+2,tempusPlotterGUI.xPos_pastColumn+tempusPlotterClip.popUp_txt._width+20,tempusPlotterGUI.yPos_ChangeSceneButtons + 20,0,0);


			if (absTime == "" || absTime == null){tempusPlotterClip.absoluteTime_txt.text = "no entry";}
			else { tempusPlotterClip.absoluteTime_txt.text =  absTime + "\n" + "( " + absGranularity +" )";}
						
			tempusPlotterClip.absoluteTime_txt.autosize = true;
			tempusPlotterClip.absoluteTime_txt.multiline = true;
			tempusPlotterClip.absoluteTime_txt.border = true;
			tempusPlotterClip.absoluteTime_txt.background = true;
			tempusPlotterClip.absoluteTime_txt.backgroundColor = 0xffccff;
			tempusPlotterClip.absoluteTime_txt.embedFonts = true;
			tempusPlotterClip.absoluteTime_txt.setTextFormat(defaultFormat);


		// Last but not least create the time distance arrows

		if (columnType != "nowColumn"){ // Conceptually the nowcolumn has no time arrows
			tempusplotterClip.createEmptyMovieClip("arrow_mc",tempusPlotterGUI.depthCounter+4);
			
			//Get the number of timerelated layers
			var timeRelatedLayers = layers[this.layerID].timeRelatedLayers;
			var num = timeRelatedLayers.length;
		   if (num > 0){ // show arrows only if the layer has time dependences
			var k;
			var timeDistance;
			var relativeGranularity;
			var tempDistanceObject;
			var tempReferencLayerNum;
			var vertDistance;
			var text;
			for (k = 0; k < num; k++)
			{
				tempDistanceObject = timeRelatedLayers[k];
				timeDistance = tempDistanceObject.timeDistance;
				relativeGranularity = tempDistanceObject.granularity;
				text = timeDistance + " " + relativeGranularity; 
				tempReferenceLayerNum = tempDistanceObject.secondLayerNumber;
				vertDistance = ((tempReferenceLayerNum -1) - this.layerID )*(height+10);
				tempusPlotterGUI.drawTimeArrow(arrow_mc,0,k*2,vertDistance,5 + k*3,text,num-k);
			
			}
			
			tempusPlotterClip.arrow_mc._x = this._x + tempusPlotterGUI.width_futureCube+5;
		 	tempusPlotterClip.arrow_mc._y = this._y + 30; //(Korrekturterm 30)
		   }
		}
	}


		cube_mc.onRollOut = function()
		{
			tempusPlotterClip.popUp_txt.removeTextField();
			tempusPlotterClip.absoluteTime_txt.removeTextField();
			tempusPlotterClip.arrow_mc.removeMovieClip();	
		}



	} //end of for-loop

return locDepthCounter;	
}








//-------------------------------------------------------------------
/**
 * Method getLayerString
 * @param layer
 */
//--------------------------------------------------------------
TempusPlotterGUI.prototype.getLayerString = function(layer){

return this.tempusPlotterObject.cTextString.slice(layer.getTextBeginning(),layer.getTextEnding());
}


//-----------------------------------------------------------------
/**
 * Method getDepthCounter()
*/
//------------------------------------------------------------------

TempusPlotterGUI.prototype.getDepthCounter = function(){
	return this.depthCounter;
}


//####################################################################
// Eventhandlers
//####################################################################




//------------------------------------------------------
/**
 * Method TempusPlotterGUI.onSceneUpdate()
 * 
 */
//------------------------------------------------------

TempusPlotterGUI.prototype.onSceneUpdate = function(){
	//
	//var fadeout = true;
	//var sceneFadeOutID = setInterval(function(){
	//	if (this.scene_mc._alpha >=5){this.scene_mc._alpha -= 5}
	//	 else {this.clearScreen();this.display();} },20); 
	
	
     
	this.clearScreen();

	this.display();

};





//------------------------------------------------------
/**
 * Method TempusPlotterGUI.popUpText()
 * 
 */
//------------------------------------------------------

TempusPlotterGUI.prototype.popUpText = function(content,depthCounter,mc,xPos,yPos){
	

			
			mc.createTextField("popUp_txt",tempusPlotterGUI.depthCounter+1,xPos,yPos,0,0);


		

			mc.popUp_txt.autosize = true;	
			mc.popUp_txt.embedFonts = true;
			mc.popUp_txt.border = true;
	
	mc.popUp_txt.text = content;
	
			
			
		//	mc.popUp_txt.background = true;
		//	mc.popUp_txt.backgroundColor = 0xffffCC;
			
		}


		




