//===================================================================
// TempusPlotterGUI
//-----------------
// This class displays the texts and data stored in TempusPlotter.as
// ==================================================================


//----------------------------------------------------------------------------
/**
 * TempusPlotterGUI Conctructor
 * @param this.tempusPlotterClip	   // The clip used to display the quiz.
 * @param tempusPlotterObject	   //	The TempusPlotter instance
 */
//-----------------------------------------------------------------------------


function TempusPlotterGUI (tempusPlotterClip, tempusPlotterObject){
	
	//trace("TempusPlotterGUI erzeugt");
	this.tempusPlotterClip = tempusPlotterClip;
	this.tempusPlotterObject = tempusPlotterObject;
	this.depthCounter = 0; 				// a unique depthcounter

	


	
	//Initialization
	
	// Set movie scale mode and alignment
		Stage.scaleMode = "noScale";
	
	// "Private" properties concerning the position of the elements on the stage
	this.xPos_cText = (Stage.width)*(3/4);
	this.yPos_cText = (Stage.height)*(3/20);
	this.height_cText = (Stage.height)*(7/10) ;
	this.width_cText = (Stage.width)*(1/4);
	this.xPos_NowColumn = 0;
	this.xPos_PastColumn = -200;
	this.xPos_FutureColumn = 200;


};




//------------------------------------------------------------------
/** Method: TempusPlotterGUI.display
 *  Desc:   Displays the whole scene
 *  First the main textfield and the buttons are created
 *  Second the columsn are drawn
 *  Third the Fadein fadeout rectangular and his buttons are drawn
 */
//------------------------------------------------------------------

TempusPlotterGUI.prototype.display = function() {
   

	this.depthCounter = 0;	// on begin of displaying set depthcounter back to 0
	this.displayScene();	
	this.displayMainText();
	


}; // Ende der Methode display()


//--------------------------------------------------------
/**
 * Method displayScene()
 *
 */
//--------------------------------------------------------


TempusPlotterGUI.prototype.displayScene = function(){


//variable for reference in callback function
var tempusPlotterClip = this.tempusPlotterClip;
var tempusPlotterGUI = this;
var tempusPlotterObject = this.tempusPlotterObject;
	



  //==========================================================
  //  Draw cubes
  //==========================================================

if (this.tempusPlotterObject.getActualScene() >=0) { //display in case we have a scene
  // Create MovieClip, which contains  all cubes
var scene_mc = this.tempusPlotterClip.createEmptyMovieClip("scene_mc",++this.depthCounter);
	scene_mc._x = 0;
	scene_mc._y = 0;
	scene_mc._alpha = 0;
	

	

  // First get the number of layers in each column
	var numberLayersNowColumn = this.tempusPlotterObject.getScenes()[this.tempusPlotterObject.getActualScene()].getNowColumn().getLayers().length;
	var numberLayersPastColumn = this.tempusPlotterObject.getScenes()[this.tempusPlotterObject.getActualScene()].getPastColumn().getLayers().length;
	var numberLayersFutureColumn = this.tempusPlotterObject.getScenes()[this.tempusPlotterObject.getActualScene()].getFutureColumn().getLayers().length;
 // Local depthcounter
 // for cubes inside scene_mc
	scene_mc.locDepthCounter =0;
	var locDepthCounter = scene_mc.locDepthCounter;

	//----------------
	// Draw PastColumn
	//----------------
	for (var i = 0;i <numberLayersPastColumn;i++)
	{  
		
		// store layer in PastColumn
		var layers = this.tempusPlotterObject.getScenes()[this.tempusPlotterObject.getActualScene()].getPastColumn().getLayers();
		var oneLayer = layers[(numberLayersPastColumn-i-1)];
		var stringPart = this.getLayerString(oneLayer);
		//trace(stringPart);
		//trace(this.tempusPlotterObject.getActualScene());
		
		var pcube_mc = this.tempusPlotterClip.scene_mc.createEmptyMovieClip("pcube_mc_"+(numberLayersPastColumn-i-1),++locDepthCounter);
		this.drawCube(pcube_mc,stringPart,0x66CCFF);
		pcube_mc._x = this.xPos_PastColumn;
		
		
		// position cubes
		if (i == 0) {
//***********
//!!!!!change
//***********			
			pcube_mc._y = 200;
		} else {
		 pcube_mc._y = this.tempusPlotterClip.scene_mc["pcube_mc_"+ (numberLayersPastColumn-i)]._y - 40;

		}
	 
	


		// attach eventhandler to cubes

		pcube_mc.onRollOver = function()
		{
			

			tempusPlotterClip.createTextField("popUp_txt",tempusPlotterGUI.depthCounter+1,this._x,this._y+70,0,0);
			tempusPlotterClip.popUp_txt.text = this.content_txt.text;
			tempusPlotterClip.popUp_txt.autosize = true;
			tempusPlotterClip.popUp_txt.border = true;
			tempusPlotterClip.popUp_txt.background = true;
			tempusPlotterClip.popUp_txt.backgroundColor = 0xffffCC;
		}


		pcube_mc.onRollOut = function()
		{
			tempusPlotterClip.popUp_txt.removeTextField();
		}



	} //end of for-loop


	//===============
	// Draw NowColumn
	//===============
	for (var i = 0;i <numberLayersNowColumn;i++)
	{  
		
		// store layer in NowColumn
		var layers = this.tempusPlotterObject.getScenes()[this.tempusPlotterObject.getActualScene()].getNowColumn().getLayers();
		var oneLayer = layers[(numberLayersNowColumn-i-1)];
		var stringPart = this.getLayerString(oneLayer);
		var ncube_mc = this.tempusPlotterClip.scene_mc.createEmptyMovieClip("ncube_mc_"+(numberLayersNowColumn-i-1),++locDepthCounter);
		this.drawCube(ncube_mc,stringPart,0x66CC00,50,150);
		ncube_mc._x = this.xPos_NowColumn;
		
		if (i == 0) {

//***********
//!!!!!change
//***********
			ncube_mc._y =200; 
		} else {
		 ncube_mc._y = this.tempusPlotterClip.scene_mc["ncube_mc_"+ (numberLayersNowColumn-i)]._y - 50;

		}
	 

		//---------------------
		// create eventhandler
		//---------------------


				ncube_mc.onRollOver = function()
		{
			
			tempusPlotterClip.createTextField("popUp_txt",tempusPlotterGUI.depthCounter+1,this._x,this._y+70,0,0);
			tempusPlotterClip.popUp_txt.text = this.content_txt.text;
			tempusPlotterClip.popUp_txt.autosize = true;
			tempusPlotterClip.popUp_txt.border = true;
			tempusPlotterClip.popUp_txt.background = true;
			tempusPlotterClip.popUp_txt.backgroundColor = 0xffffCC;
		}


		ncube_mc.onRollOut = function()
		{
			tempusPlotterClip.popUp_txt.removeTextField();
		}
		


	} //end of for-loop

	
	//----------------
	// Draw FutureColumn
	//----------------
	for (var i = 0;i <numberLayersPastColumn;i++)
	{  
		
		// store layer in PastColumn
		var layers = this.tempusPlotterObject.getScenes()[this.tempusPlotterObject.getActualScene()].getFutureColumn().getLayers();
		var oneLayer = layers[(numberLayersFutureColumn-i-1)];
		var stringPart = this.getLayerString(oneLayer);
		//trace(stringPart);
		//trace(this.tempusPlotterObject.getActualScene());
		
		var fcube_mc = this.tempusPlotterClip.scene_mc.createEmptyMovieClip("fcube_mc_"+(numberLayersFutureColumn-i-1),++locDepthCounter);
		this.drawCube(fcube_mc,stringPart,0xff0000);
		fcube_mc._x = this.xPos_FutureColumn;
		
		
		
		if (i == 0) {
//***********
//!!!!!change
//***********			
			fcube_mc._y = 200;
		} else {
		 fcube_mc._y = this.tempusPlotterClip.scene_mc["fcube_mc_"+ (numberLayersFutureColumn-i)]._y - 40;

		}
	 
	


	

		fcube_mc.onRollOver = function()
		{
			

			tempusPlotterClip.createTextField("popUp_txt",tempusPlotterGUI.depthCounter+1,this._x,this._y+70,0,0);
			tempusPlotterClip.popUp_txt.text = this.content_txt.text;
			tempusPlotterClip.popUp_txt.autosize = true;
			tempusPlotterClip.popUp_txt.border = true;
			tempusPlotterClip.popUp_txt.background = true;
			tempusPlotterClip.popUp_txt.backgroundColor = 0xffffCC;
		}


		fcube_mc.onRollOut = function()
		{
			tempusPlotterClip.popUp_txt.removeTextField();
		}



	} //end of for-loop


	//===============================
	// Fade in mechanism for scene_mc
	//===============================
	
      scene_mc.onEnterFrame = function(){
		if (scene_mc._alpha < 105){
			scene_mc._alpha +=5;
			
		}
		
	}

} // end of if-body


	// ----------------------------------
	// Buttons for changing between scenes
	// ----------------------------------
	
	var nextScene_mc = this.tempusPlotterClip.createEmptyMovieClip("nextScene_mc",++this.depthCounter);
	nextScene_mc.createTextfield("next_txt",1,0,0,0,0);
	nextScene_mc.next_txt.text = "Next";
	nextScene_mc.next_txt.autoSize = true;
	nextScene_mc.next_txt.border = true;
	nextScene_mc._x = 40;
	nextScene_mc._y = 0;

	var backScene_mc = this.tempusPlotterClip.createEmptyMovieClip("backScene_mc",++this.depthCounter);
	backScene_mc.createTextfield("back_txt",1,0,0,0,0);
	backScene_mc.back_txt.text = "Back";
	backScene_mc.back_txt.autoSize = true;
	backScene_mc.back_txt.border = true;
	backScene_mc._x = 0;
	backScene_mc._y = 0;


	//---------------------------
	// Callback for Nextbutton
	//---------------------------
	
	if (tempusPlotterObject.getActualScene() < tempusPlotterObject.getScenes().length -1) {
		nextScene_mc.onPress = function(){
			tempusPlotterObject.setActualScene(tempusPlotterObject.getActualScene()+ 1);
		}
	} else {
		new Color(nextScene_mc).setRGB(0x999999);
    	}

	//---------------------------
	// Callback for Backbutton
	//---------------------------

     
	if (tempusPlotterObject.getActualScene() >= 0){	
		backScene_mc.onPress = function(){
		  tempusPlotterObject.setActualScene(tempusPlotterObject.getActualScene()-1);		
		}
	} else { 
		new Color(backScene_mc).setRGB(0x999999);
    	}

}; // end of method displayScene() 


















//------------------------------------------------------
/**
 * Method TempusPlotterGUI.clearScreen()
 * 
 */
//------------------------------------------------------

TempusPlotterGUI.prototype.clearScreen = function () {
  for (var p in this.tempusPlotterClip) {
    if (typeof this.tempusPlotterClip[p] == "movieclip") {
      this.tempusPlotterClip[p].removeMovieClip();
    } else if (this.tempusPlotterClip[p] instanceof TextField) {
      this.tempusPlotterClip[p].removeTextField();
    }
  }
};



//-------------------------------------------------------------
/**
 * Method displayMainText()
 *
 */
//--------------------------------------------------------------


TempusPlotterGUI.prototype.displayMainText = function(){
	
	

	

	//-----------------------------
	// Create main textfield
	//-----------------------------


	this.tempusPlotterClip.createTextField("cTextfield_txt", ++this.depthCounter, 0,0, 0, 0);
	// Assign the cTextSring to the CTextfield
	this.tempusPlotterClip.cTextfield_txt.text =
          this.tempusPlotterObject.cTextString;
	this.tempusPlotterClip.cTextfield_txt._x = this.xPos_cText;
	this.tempusPlotterClip.cTextfield_txt._y = this.yPos_cText;
	this.tempusPlotterClip.cTextfield_txt._height = this.height_cText;
	this.tempusPlotterClip.cTextfield_txt._width = this.width_cText;
	
	this.tempusPlotterClip.cTextfield_txt.multiline = true;
	this.tempusPlotterClip.cTextfield_txt.border = true;
	this.tempusPlotterClip.cTextfield_txt.wordWrap = true;

      //the Description of the Textfield
	this.tempusPlotterClip.createTextField("DescOfMainText_txt",++this.depthCounter,0,0,0,0);
	this.tempusPlotterClip.DescOfMainText_txt.text = "Main Text";
	this.tempusPlotterClip.DescOfMainText_txt.autoSize = true;
	this.tempusPlotterClip.DescOfMainText_txt._x = cTextfield_txt._x +
((cTextfield_txt._width -  DescOfMainText_txt._width)/2);
	this.tempusPlotterClip.DescOfMainText_txt._y = cTextfield_txt._y/2;
	this.tempusPlotterClip.DescOfMainText_txt.border = true;
	this.tempusPlotterClip.DescOfMainText_txt.selectable = false;
	//DescOfMainText_txt.borderColor = 0xFFFFF; //blaue Umrandung
	//this.tempusPlotterClip.DescOfMainText_txt.background = true;
	//this.tempusPlotterClip.DescOfMainText_txt.backgroundColor = 0x00FFFF;




    	 //-------------------------------------------
    	 // Generate Buttons for Scrolling up and Down
   	 // ---------------------------------------------

	var scrollUp_mc =
this.tempusPlotterClip.createEmptyMovieClip("scrollUp_mc",++this.depthCounter);
	var scrollDown_mc =
this.tempusPlotterClip.createEmptyMovieClip("scrollDown_mc",++this.depthCounter);

   // Draw triangles in the Clips 
	


	// for Upscroller
	scrollUp_mc.lineStyle(0);
	scrollUp_mc.moveTo(0,14);
	scrollUp_mc.beginFill(0xff0000);
	scrollUp_mc.lineTo(10,14);
	scrollUp_mc.lineTo(5,4);
	scrollUp_mc.lineTo(0,14);
	


	//for DownScroller
	scrollDown_mc.lineStyle(0);
	scrollDown_mc.moveTo(0,4);
	scrollDown_mc.beginFill(0xff0000);
	scrollDown_mc.lineTo(5,14);
	scrollDown_mc.lineTo(10,4);
	scrollDown_mc.lineTo(0,4);
	
	//Position UpScroller
	scrollUp_mc._x = this.tempusPlotterClip.cTextfield_txt._x
+(this.tempusPlotterClip.cTextfield_txt._width)/2  - 14;
	scrollUp_mc._y = this.tempusPlotterClip.cTextfield_txt._y +
this.tempusPlotterClip.cTextfield_txt._height  +10;


	//Position DownScroller
	scrollDown_mc._x = this.tempusPlotterClip.cTextfield_txt._x + 
(this.tempusPlotterClip.cTextfield_txt._width)/2 +14;
	scrollDown_mc._y = this.tempusPlotterClip.cTextfield_txt._y +
this.tempusPlotterClip.cTextfield_txt._height  + 10;

	//convenient description for use in callback function
	var tempusPlotterClip = this.tempusPlotterClip;
	


	// Assign the buttons behaviour
		scrollDown_mc.onPress = function(){
			
			if (tempusPlotterClip.cTextfield_txt.scroll <
tempusPlotterClip.cTextfield_txt.maxscroll)
			{
					tempusPlotterClip.cTextfield_txt.scroll++;
					
			}
		};
		
		scrollUp_mc.onPress = function(){
			//trace("ScrollDown_mc bettigt");
			if (tempusPlotterClip.cTextfield_txt.scroll > 1)
			{
			
				tempusPlotterClip.cTextfield_txt.scroll--;
			}
		};
} // End of Method displayMainText





//-----------------------------------------------------------------
/**
 * Method drawCube()
 * @param mc the movieclip, which the cube is drawn into
 * @param content textstring to appear in front of the cubes
 * @param color  
 * @param cubeHeight
 * @param cubeWidth
 * 
 * Description: In case the number of arguments is smaller than 5
 * 		    cubes are drawn with default values
*/
//-----------------------------------------------------------------

TempusPlotterGUI.prototype.drawCube = function(mc,content,color,cubeHeight,cubeWidth) {
	//trace("Methode drawcube aufgerufen");
	var cubeXPosInClip = 0;
	var cubeYPosInClip = 30;
	if (arguments.length <5) {
	    var cubeWidth = 100;
	}
	if (arguments.length <4) {
		var cubeHeight = 30;
	}    
	if (arguments.length <3) {
		var color = 0xff0000; //red cube as defaulfcolor	    
	}
	if (arguments.length < 2) {
		var content = "default";
	}
mc.lineStyle(1, 0xFFFFFF, 100);
mc.beginFill(color,100);

mc.moveTo(cubeXPosInClip,cubeYPosInClip);
mc.lineTo(cubeXPosInClip + cubeWidth/3,cubeYPosInClip -cubeHeight/2);
mc.lineTo(cubeXPosInClip + (4/3)*cubeWidth,cubeYPosInClip -
cubeHeight/2);
mc.lineTo(cubeXPosInClip + (4/3)*cubeWidth,cubeYPosInClip +
cubeHeight/2);
mc.lineTo(cubeWidth +this.cubeXPosInClip,cubeYPosInClip + cubeHeight);
mc.lineTo(cubeXPosInClip,cubeYPosInClip + cubeHeight);
mc.lineTo(cubeXPosInClip,cubeYPosInClip);
mc.endFill();

//Draw inner "Y" of the cube
mc.lineTo(cubeXposInClip+cubeWidth,cubeYPosInClip);
mc.lineTo(cubeXPosInClip +4/3*cubeWidth,cubeYPosInClip-cubeHeight/2);
mc.moveTo(cubeXposInClip+cubeWidth,cubeYPosInClip);
mc.lineTo(cubeXposInClip+cubeWidth,cubeYPosInClip +  cubeHeight);


  //create Textfield into the front of the cube and 
  // initialize with specified textstring content
mc.createTextField("content_txt",1,cubeXPositionInClip,cubeYPositionInClip+cubeHeight+5,cubeWidth,cubeHeight);

//Use Embedded Font to make _alpha property accessible
mc.content_txt.embedFonts = true;
mc.content_txt.text = content;
defaultFormat = new TextFormat();
defaultFormat.font ="Arial";
mc.content_txt.setTextFormat(defaultFormat);

};



//-------------------------------------------------------------------
/**
 * Method getLayerString
 * @param layer
 */
//--------------------------------------------------------------
TempusPlotterGUI.prototype.getLayerString = function(layer){

return this.tempusPlotterObject.cTextString.slice(parseInt(layer.getTextBeginning()),parseInt(layer.getTextEnding()));
}


//-----------------------------------------------------------------
/**
 * Method getDepthCounter()
*/
//------------------------------------------------------------------

TempusPlotterGUI.prototype.getDepthCounter = function(){
	return this.depthCounter;
}


//####################################################################
// Eventhandlers
//####################################################################

//------------------------------------------------------
/**
 * Method TempusPlotterGUI.onSceneUpdate()
 * 
 */
//------------------------------------------------------

TempusPlotterGUI.prototype.onSceneUpdate = function(){
	//
	this.clearScreen();
	//this.displayMainText();
	//this.displayScene();	
	this.display();

};


//!! Doesnt work yet with this method


//------------------------------------------------------
/**
 * Method TempusPlotterGUI.popUpText()
 * 
 */
//------------------------------------------------------

TempusPlotterGUI.prototype.popUpText = function(content,depthCounter,mc,xPos,yPos){
	

			
			mc.createTextField("popUp_txt",tempusPlotterGUI.depthCounter+1,xPos,yPos,0,0);
			mc.popUp_txt.text = content;
			mc.popUp_txt.autosize = true;
			mc.popUp_txt.border = true;
			mc.popUp_txt.background = true;
			mc.popUp_txt.backgroundColor = 0xffffCC;
		}


		









